# Get Hourly Report Root Presets

GET https://api.letsdeel.com/rest/v2/timesheets/root-presets

Retrieve a list of hourly report root presets.
 **Token scopes**: `timesheets:read`

Reference: https://developer.deel.com/api/reference/endpoints/projects/get-hourly-report-root-presets

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: Deel HRIS SCIM API
  version: 1.0.0
paths:
  /timesheets/root-presets:
    get:
      operationId: get-hourly-report-root-presets
      summary: Get Hourly Report Root Presets
      description: |-
        Retrieve a list of hourly report root presets.
         **Token scopes**: `timesheets:read`
      tags:
        - subpackage_projects
      parameters:
        - name: limit
          in: query
          description: 'Maximum number of items to return per page (max: 100)'
          required: false
          schema:
            type: integer
            default: 10
        - name: order_by
          in: query
          description: Field to order the results by
          required: false
          schema:
            $ref: '#/components/schemas/TimesheetsRootPresetsGetParametersOrderBy'
        - name: order_direction
          in: query
          description: Direction to order the results (ascending or descending)
          required: false
          schema:
            $ref: >-
              #/components/schemas/TimesheetsRootPresetsGetParametersOrderDirection
        - name: work_statement_statuses
          in: query
          description: Filter results by work statement status
          required: false
          schema:
            type: array
            items:
              type: string
        - name: cursor
          in: query
          description: Pagination cursor for fetching the next page of results
          required: false
          schema:
            type: string
        - name: Authorization
          in: header
          description: >
            ## Authentication

            The Deel API uses bearer tokens to authenticate requests. All API
            calls must be made over HTTPS — calls over plain HTTP or without
            authentication will fail.


            ```curl

            curl -X GET 'https://api.letsdeel.com/rest/v2/contracts' \
              -H 'Authorization: Bearer YOUR-TOKEN-HERE'
            ```


            [Learn more about authentication](/api/authentication)
          required: true
          schema:
            type: string
      responses:
        '200':
          description: Successful operation.
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/Projects_getHourlyReportRootPresets_Response_200
        '400':
          description: Bad Request
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/GetHourlyReportRootPresetsRequestBadRequestError
        '401':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
        '403':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
        '404':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
        '500':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
servers:
  - url: https://api.letsdeel.com/rest/v2
  - url: https://api-staging.letsdeel.com/rest/v2
components:
  schemas:
    TimesheetsRootPresetsGetParametersOrderBy:
      type: string
      enum:
        - created_at
      default: created_at
      title: TimesheetsRootPresetsGetParametersOrderBy
    TimesheetsRootPresetsGetParametersOrderDirection:
      type: string
      enum:
        - ASC
        - DESC
      default: DESC
      title: TimesheetsRootPresetsGetParametersOrderDirection
    TimesheetsRootPresetsGetResponsesContentApplicationJsonSchemaDataItemsFile:
      type: object
      properties:
        id:
          type: string
          description: The unique identifier of the file
        name:
          type: string
          description: The name of the file
        type:
          type: string
          description: The type of the file
      title: >-
        TimesheetsRootPresetsGetResponsesContentApplicationJsonSchemaDataItemsFile
    TimesheetsRootPresetsGetResponsesContentApplicationJsonSchemaDataItemsType:
      type: string
      enum:
        - RATE
        - TRACKING
      description: >-
        The type of preset, RATE – indicates a preset that overrides the default
        contract rate, TRACKING - used exclusively for tracking, applying the
        default contract rate
      title: >-
        TimesheetsRootPresetsGetResponsesContentApplicationJsonSchemaDataItemsType
    TimesheetsRootPresetsGetResponsesContentApplicationJsonSchemaDataItems:
      type: object
      properties:
        id:
          type: string
          format: uuid
          description: The unique identifier of the hourly report root preset
        file:
          oneOf:
            - $ref: >-
                #/components/schemas/TimesheetsRootPresetsGetResponsesContentApplicationJsonSchemaDataItemsFile
            - type: 'null'
        type:
          $ref: >-
            #/components/schemas/TimesheetsRootPresetsGetResponsesContentApplicationJsonSchemaDataItemsType
          description: >-
            The type of preset, RATE – indicates a preset that overrides the
            default contract rate, TRACKING - used exclusively for tracking,
            applying the default contract rate
        title:
          type: string
          description: The title of the hourly report root preset
        description:
          type: string
          description: Detailed description of the hourly report root preset
        contracts_count:
          type: integer
          description: Number of contracts using this root preset
        hourly_report_presets_count:
          type: integer
          description: Number of hourly report presets created from this root preset
      required:
        - id
        - title
        - description
        - contracts_count
        - hourly_report_presets_count
      title: TimesheetsRootPresetsGetResponsesContentApplicationJsonSchemaDataItems
    TimesheetsRootPresetsGetResponsesContentApplicationJsonSchemaPage:
      type: object
      properties:
        cursor:
          type: string
          description: Pagination cursor for fetching the next set of results
        total_rows:
          type: integer
          description: Total number of root presets available
      required:
        - cursor
        - total_rows
      title: TimesheetsRootPresetsGetResponsesContentApplicationJsonSchemaPage
    Projects_getHourlyReportRootPresets_Response_200:
      type: object
      properties:
        data:
          type: array
          items:
            $ref: >-
              #/components/schemas/TimesheetsRootPresetsGetResponsesContentApplicationJsonSchemaDataItems
        page:
          $ref: >-
            #/components/schemas/TimesheetsRootPresetsGetResponsesContentApplicationJsonSchemaPage
      required:
        - data
        - page
      title: Projects_getHourlyReportRootPresets_Response_200
    GetHourlyReportRootPresetsRequestBadRequestError:
      type: object
      properties:
        error:
          type: string
      title: GetHourlyReportRootPresetsRequestBadRequestError
    ApiErrorRequest:
      type: object
      properties:
        method:
          type: string
          description: The HTTP method of the failed request
        url:
          type: string
          description: The relative URL of the failed request
        status:
          type: number
          format: double
          description: The status code of the response
        api_req_id:
          type: string
          description: The request ID of the failed request
        docs:
          type: string
          description: >-
            A link to the official documentation for the requested endpoint
            resource
        source:
          type: string
          description: The source handler which produced the returned error
        code:
          type: number
          format: double
          description: The code of the source handler which produced the returned error
      title: ApiErrorRequest
    ApiError:
      type: object
      properties:
        message:
          type: string
          description: A description of the returned error
        path:
          type: string
          description: The JSON path where input validation failed
      title: ApiError
    ApiErrorContainer:
      type: object
      properties:
        request:
          $ref: '#/components/schemas/ApiErrorRequest'
        errors:
          type: array
          items:
            $ref: '#/components/schemas/ApiError'
      title: ApiErrorContainer
  securitySchemes:
    deelToken:
      type: http
      scheme: bearer
      description: >
        ## Authentication

        The Deel API uses bearer tokens to authenticate requests. All API calls
        must be made over HTTPS — calls over plain HTTP or without
        authentication will fail.


        ```curl

        curl -X GET 'https://api.letsdeel.com/rest/v2/contracts' \
          -H 'Authorization: Bearer YOUR-TOKEN-HERE'
        ```


        [Learn more about authentication](/api/authentication)
    oauth2:
      type: http
      scheme: bearer
      description: >-
        Standard OAuth2 security scheme based on
        https://swagger.io/docs/specification/authentication/

```

## SDK Code Examples

```python
import requests

url = "https://api.letsdeel.com/rest/v2/timesheets/root-presets"

querystring = {"limit":"20","order_by":"created_at","order_direction":"DESC","work_statement_statuses":"[\"ACTIVE\",\"PENDING\"]","cursor":"next_page_token_123"}

headers = {"Authorization": "Bearer <token>"}

response = requests.get(url, headers=headers, params=querystring)

print(response.json())
```

```javascript
const url = 'https://api.letsdeel.com/rest/v2/timesheets/root-presets?limit=20&order_by=created_at&order_direction=DESC&work_statement_statuses=%5B%22ACTIVE%22%2C%22PENDING%22%5D&cursor=next_page_token_123';
const options = {method: 'GET', headers: {Authorization: 'Bearer <token>'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://api.letsdeel.com/rest/v2/timesheets/root-presets?limit=20&order_by=created_at&order_direction=DESC&work_statement_statuses=%5B%22ACTIVE%22%2C%22PENDING%22%5D&cursor=next_page_token_123"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("Authorization", "Bearer <token>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.letsdeel.com/rest/v2/timesheets/root-presets?limit=20&order_by=created_at&order_direction=DESC&work_statement_statuses=%5B%22ACTIVE%22%2C%22PENDING%22%5D&cursor=next_page_token_123")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = 'Bearer <token>'

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://api.letsdeel.com/rest/v2/timesheets/root-presets?limit=20&order_by=created_at&order_direction=DESC&work_statement_statuses=%5B%22ACTIVE%22%2C%22PENDING%22%5D&cursor=next_page_token_123")
  .header("Authorization", "Bearer <token>")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://api.letsdeel.com/rest/v2/timesheets/root-presets?limit=20&order_by=created_at&order_direction=DESC&work_statement_statuses=%5B%22ACTIVE%22%2C%22PENDING%22%5D&cursor=next_page_token_123', [
  'headers' => [
    'Authorization' => 'Bearer <token>',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.letsdeel.com/rest/v2/timesheets/root-presets?limit=20&order_by=created_at&order_direction=DESC&work_statement_statuses=%5B%22ACTIVE%22%2C%22PENDING%22%5D&cursor=next_page_token_123");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "Bearer <token>");
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = ["Authorization": "Bearer <token>"]

let request = NSMutableURLRequest(url: NSURL(string: "https://api.letsdeel.com/rest/v2/timesheets/root-presets?limit=20&order_by=created_at&order_direction=DESC&work_statement_statuses=%5B%22ACTIVE%22%2C%22PENDING%22%5D&cursor=next_page_token_123")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```